找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 2026|回复: 7

[LISP程序]:清除重复的实体

[复制链接]
发表于 2003-1-26 21:15:39 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×

  1. ;| Programmed by Dave Aguilar
  2.    DUPREM.LSP <c> 1994 Onyx Software

  3. This program creates an list of entity lists for all entities in the
  4. drawing (using the first VERTEX for POLYLINES) and then compares each
  5. entity list with the total list, building a new selection set of all
  6. duplicate entries which are then erased.

  7. it's not guarenteed but try it on a copy of a badly duplicated drawing
  8. and see if it helps.

  9. ------------------------------------------------------------------------
  10. ------------------------------------------------------------------------
  11. Modified by J. Tippit, SPAUG President                                08/25/99
  12.     E-mail:                     [email]cadpres@spaug.org[/email]
  13.     Web Site:                [url]http://www.spaug.org[/url]

  14.         1. Modified to work with R14 & 2000
  15.         2. Now prompts for 3 types of selection sets
  16.         3. Works on all types of entities (including LWPOLYLINES)

  17. Large donations to SPAUG is appreciated. :)
  18. ------------------------------------------------------------------------
  19. ------------------------------------------------------------------------

  20. |;

  21. (defun C:DUPREM ()
  22.    (setvar "cmdecho" 0)
  23.    (setq f1 nil f1 0)
  24. ; Added by Jeff Tippit 08/25/99
  25. ; Start
  26.    (initget "S L E")
  27.    (setq SLE (getkword "\nSelect objects by [S] election set, [L]imits, or [E] ntire database: "))
  28.    (cond
  29.       ((= SLE "S")(setq sa (ssget)))
  30.       ((= SLE "L")(setq sa (ssget "c" (getvar "extmin")(getvar "extmax"))))
  31.       ((= SLE "E")(setq sa (ssget "X")))
  32.    )
  33. ; End
  34.    (setq ca 0 ta (sslength sa) la nil lb nil)
  35.    (while (< ca ta)
  36.       (setq enta (ssname sa ca) ea (cdr (entget enta))
  37.             typa (cdr (assoc 0 ea))
  38.       )
  39. ;      (if (= typa "POLYLINE") (progn
  40. ;         (setq entb (entnext enta) ea (cdr (entget entb)))
  41. ;      ))

  42. ; Added by Jeff Tippit 08/25/99
  43. ; Updated for R14 & 2000
  44. ; Start
  45.    (setq a1 (assoc 5 ea))
  46.    (setq a2 (cons 5 ""))
  47.    (setq ea (subst a2 a1 ea))
  48.    (if (wcmatch (getvar "ACADVER") "*15*")
  49.       (progn
  50.          (setq a3 (assoc 330 ea))
  51.          (setq a4 (cons 330 ""))
  52.          (setq ea (subst a4 a3 ea))
  53.       )
  54.    )
  55. ; End
  56.       (setq la (cons enta la) lb (cons ea lb)
  57.             ca (+ ca 1)
  58.       )
  59.    )
  60.    (setq sc nil sc (ssadd) ltest lb)
  61.    (setq ca 0)
  62.    (setq tes (car ltest) ltest (cdr ltest) ta nil ta (length ltest))
  63.    (while (/= ta 0)
  64.       (if (member tes ltest) (progn
  65.          (setq sc (ssadd (nth ca la) sc))
  66.          (prompt "\nFound duplicate entity.")
  67.          (setq f1 (+ f1 1))
  68.       ))
  69.       (setq ca (+ ca 1))
  70.       (setq tes (car ltest) ltest (cdr ltest) ta (length ltest))
  71.    )
  72.    (command "erase" sc "")
  73.    (redraw)
  74.    (prompt "\n")(prin1 f1)(prompt " duplicate entities erased.")
  75.    (princ)
  76. )
  77. (prompt "\nType DUPREM to run. Delete duplicate entity routine Ver 2.0 loaded.")
  78. (princ)
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
发表于 2003-1-27 14:07:05 | 显示全部楼层
你這個好用嗎?哪裡找來的,貼一個沒有刪除線的吧!!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2003-1-28 14:19:06 | 显示全部楼层

Re: [LISP程序]:清除重复的实体

最初由 mmmm 发布
[B][code]
;| Programmed by Dave Aguilar
   DUPREM.LSP <c> 1994 Onyx Software

This program creates an list of entity lists for all entities in the
drawing (using the first VERTEX for POLYLINES) a... [/B]

copy 就能清除
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2003-2-6 11:52:39 | 显示全部楼层

  1. ;;這是一個刪除完全重疊物件的程序
  2. ;;我也忘了是甚麼時候看到
  3. ;;當時只修改了一些就收起來!!

  4. ;| Programmed by Dave Aguilar
  5.    DUPREM.LSP  1994 Onyx Software

  6. This program creates an list of entity lists for all entities in the
  7. drawing (using the first VERTEX for POLYLINES) and then compares each
  8. entity list with the total list, building a new selection set of all
  9. duplicate entries which are then erased.

  10. it's not guarenteed but try it on a copy of a badly duplicated drawing
  11. and see if it helps.

  12. ------------------------------------------------------------------------
  13. ------------------------------------------------------------------------
  14. Modified by J. Tippit, SPAUG President                                08/25/99
  15.     E-mail:                     [email]cadpres@spaug.org[/email]
  16.     Web Site:                [url]http://www.spaug.org[/url]

  17.         1. Modified to work with R14 & 2000
  18.         2. Now prompts for 3 types of selection sets
  19.         3. Works on all types of entities (including LWPOLYLINES)

  20. Large donations to SPAUG is appreciated. :)
  21. ------------------------------------------------------------------------
  22. ------------------------------------------------------------------------

  23. |;

  24. (defun C:DUPREM        ()
  25.   (setvar "cmdecho" 0)
  26.   (setq        F1 NIL
  27.         F1 0
  28.   )
  29.   ;; Added by Jeff Tippit 08/25/99
  30.   ;; Start
  31.   (initget "S L A")
  32.   (setq        SLE
  33.          (getkword
  34.            "\nSelect objects by (S)election set, (L)imits, or (A)ll: "
  35.          )
  36.   )
  37.   (cond
  38.     ((= SLE "S") (setq SA (ssget)))
  39.     ((= SLE "L")
  40.      (setq SA (ssget "c" (getvar "extmin") (getvar "extmax")))
  41.     )
  42.     ((= SLE "A")
  43.      (setq SA (ssget "X" (list (cons 410 (getvar "CTAB")))))
  44.     )
  45.   )
  46.   ;; End
  47.   (setq        CA 0
  48.         TA (sslength SA)
  49.         LA NIL
  50.         LB NIL
  51.   )
  52.   (while (< CA TA)
  53.     (setq ENTA (ssname SA CA)
  54.           EA   (cdr (entget ENTA))
  55.           TYPA (cdr (assoc 0 EA))
  56.     )
  57.     ;;      (if (= typa "POLYLINE") (progn
  58.     ;;         (setq entb (entnext enta) ea (cdr (entget entb)))
  59.     ;;      ))

  60.     ;; Added by Jeff Tippit 08/25/99
  61.     ;; Updated for R14 & 2000
  62.     ;; Start
  63.     (setq A1 (assoc 5 EA))
  64.     (setq A2 (cons 5 ""))
  65.     (setq EA (subst A2 A1 EA))
  66.     (if        (wcmatch (getvar "ACADVER") "*15*")
  67.       (progn
  68.         (setq A3 (assoc 330 EA))
  69.         (setq A4 (cons 330 ""))
  70.         (setq EA (subst A4 A3 EA))
  71.       )
  72.     )
  73.     ;; Added by Lucas
  74.     (if        (= TYPA "VIEWPORT")
  75.       (progn
  76.         (setq A3 (assoc 69 EA))
  77.         (setq A4 (cons 69 ""))
  78.         (setq EA (subst A4 A3 EA))
  79.         (setq A3 (assoc 68 EA))
  80.         (setq A4 (cons 68 ""))
  81.         (setq EA (subst A4 A3 EA))
  82.       )
  83.     )
  84.     ;; End
  85.     (setq LA (cons ENTA LA)
  86.           LB (cons EA LB)
  87.           CA (+ CA 1)
  88.     )
  89.   )
  90.   (setq        SC    NIL
  91.         SC    (ssadd)
  92.         LTEST LB
  93.   )
  94.   (setq CA 0)
  95.   (setq        TES   (car LTEST)
  96.         LTEST (cdr LTEST)
  97.         TA    NIL
  98.         TA    (length LTEST)
  99.   )
  100.   (while (/= TA 0)
  101.     (if        (member TES LTEST)
  102.       (progn
  103.         (setq SC (ssadd (nth CA LA) SC))
  104.         ;;(prompt "\nFound aduplicate entity.")
  105.         (setq F1 (+ F1 1))
  106.       )
  107.     )
  108.     (setq CA (+ CA 1))
  109.     (setq TES        (car LTEST)
  110.           LTEST        (cdr LTEST)
  111.           TA        (length LTEST)
  112.     )
  113.   )
  114.   (command "_.erase" SC "")
  115.   (redraw)
  116.   (prompt "\n")
  117.   (prin1 F1)
  118.   (prompt " duplicate entities erased.")
  119.   (princ)
  120. )

  121. (prompt
  122.   "\nType DUPREM to run. Delete duplicate entity routine Ver 2.0 loaded."
  123. )
  124. (princ)

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2003-2-6 16:54:33 | 显示全部楼层
根据本人的需要而修改,喜欢就下吧
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2006-6-13 01:48:24 | 显示全部楼层
是完全重合是有一定误差的
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2009-4-23 10:38:29 | 显示全部楼层
5楼的好使
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2013-4-27 13:59:58 | 显示全部楼层
谢谢!收藏了!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 21:17 , Processed in 0.189970 second(s), 47 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表